// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'LogFile.pas' rev: 5.00

#ifndef LogFileHPP
#define LogFileHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <LogBase.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Logfile
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS EFileNotificationError;
class PASCALIMPLEMENTATION EFileNotificationError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EFileNotificationError(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EFileNotificationError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EFileNotificationError(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EFileNotificationError(int Ident, const System::TVarRec 
		* Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EFileNotificationError(const AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EFileNotificationError(const AnsiString Msg, const 
		System::TVarRec * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size
		, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EFileNotificationError(int Ident, int AHelpContext)
		/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EFileNotificationError(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EFileNotificationError(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TFileNotificationOption { foFile, foFolder, foAttributes, foSize, foTime, foWatchSubFolders };
#pragma option pop

typedef Set<TFileNotificationOption, foFile, foWatchSubFolders>  TFileNotificationOptions;

typedef void __fastcall (__closure *TFileNotifyEvent)(System::TObject* Sender, TFileNotificationOption 
	Action);

class DELPHICLASS TNotificationThread;
class DELPHICLASS TSMFileLog;
class PASCALIMPLEMENTATION TSMFileLog : public Logbase::TSMLogBase 
{
	typedef Logbase::TSMLogBase inherited;
	
private:
	TNotificationThread* FThread;
	AnsiString FFolder;
	TFileNotificationOptions FOptions;
	TFileNotifyEvent FOnFileNotification;
	void __fastcall SetOptions(TFileNotificationOptions Value);
	void __fastcall SetFolder(AnsiString Value);
	
protected:
	virtual void __fastcall Notify(TFileNotificationOption Action);
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TSMFileLog(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMFileLog(void);
	
__published:
	__property AnsiString Folder = {read=FFolder, write=SetFolder};
	__property TFileNotificationOptions Options = {read=FOptions, write=SetOptions, nodefault};
	__property TFileNotifyEvent OnFileNotification = {read=FOnFileNotification, write=FOnFileNotification
		};
};


class PASCALIMPLEMENTATION TNotificationThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	TSMFileLog* FOwner;
	unsigned FHandles[8];
	TFileNotificationOption FHandleFilters[8];
	int FHandleCount;
	TFileNotificationOption FActiveFilter;
	void __fastcall ReleaseHandles(void);
	void __fastcall AllocateHandles(void);
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall Notify(void);
	
public:
	__fastcall TNotificationThread(TSMFileLog* Owner);
	__fastcall virtual ~TNotificationThread(void);
	void __fastcall Reset(void);
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Logfile */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Logfile;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// LogFile
